/*
 thread.js | (c) 2015 Spencer Evans | MIT License (MIT) https://github.com/swevans/thread.js/blob/master/LICENSE */
(function(){if("undefined"!==typeof threadjs){if("undefined"===typeof Window)throw Error("threadjs is already defined, you don't need to import the script on child threads created using threadjs! Did you attempt to load the script twice? Do you possibly have a conflicting reference?");throw Error("threadjs is already defined, did you attempt to load the script twice? Do you possibly have a conflicting reference?");}})();var threadjs;
(function(d){d.url=null;d.allowInlineWorkers=!0;Object.defineProperty(d,"maxWorkers",{get:function(){if(!d.Thread.isMainThread)throw Error("maxWorkers is only valid on the main thread!");return d.Thread._maxWorkers},set:function(e){if(!d.Thread.isMainThread)throw Error("maxWorkers is only valid on the main thread!");if(1>e)try{console.warn("Setting maxWorkers below 1 will result in no threads starting!")}catch(f){}if(999<e)throw Error("ThreadJS does not support over 999 threads!");if(16<e)try{console.warn("Setting maxWorkers above 16 may result in a browser crash!")}catch(a){}d.Thread._maxWorkers=
e;d.Thread.permitCheck()}});Object.defineProperty(d,"isSupported",{get:function(){return"undefined"===typeof Worker?!1:!0}})})(threadjs||(threadjs={}));(function(){if("undefined"!==typeof Window){var d=document.getElementsByTagName("script");0<d.length&&(d=d[d.length-1],d.hasAttribute("src")&&(threadjs.url=d.getAttribute("src")))}})();
(function(d){var e=function(){function d(){}d.prototype.addEventListener=function(a,c){"undefined"===typeof this._handlers&&(this._handlers=[]);var b={};b.type=a;b.listener=c;b.invalid=!1;this._handlers.push(b)};d.prototype.removeEventListener=function(a,c){"undefined"===typeof this._handlers&&(this._handlers=[]);for(var b=0;b<this._handlers.length;++b){var d=this._handlers[b];if(d.type===a&&d.listener===c){d.invalid=!0;this._handlers.splice(b,1);break}}};d.prototype.dispatchEvent=function(a){"undefined"===
typeof this._handlers&&(this._handlers=[]);for(var c=this._handlers.slice(),b=0;b<c.length;++b){var d=c[b];!0!==d.invalid&&d.type===a.type&&d.listener(a)}};return d}();d.EventDispatcher=e})(threadjs||(threadjs={}));var __extends=this&&this.__extends||function(d,e){function f(){this.constructor=d}for(var a in e)e.hasOwnProperty(a)&&(d[a]=e[a]);d.prototype=null===e?Object.create(e):(f.prototype=e.prototype,new f)};
(function(d){var e=function(e){function a(c){e.call(this);this.postEvent=this.postEvent.bind(this);this._scope=c;d.Thread.isMainThread||(this.scope_message=this.scope_message.bind(this),c.addEventListener("message",this.scope_message,!1))}__extends(a,e);a.prototype.postMessage=function(c){this._scope.postMessage(c)};a.prototype.postEvent=function(c,b){void 0===b&&(b=null);if("string"===typeof c)c=new d.ThreadEvent(c,b);else if(c instanceof Event)c=d.ThreadEvent.copyNative(c);else if("string"!==typeof c.type)throw Error("Missing string event type on supplied threadEvent parameter!");
this.postMessage({threadjsCmd:"postEvent",threadEvent:c})};a.prototype.scope_message=function(c){var b=c.data;if("init"===b.threadjsCmd)d.Thread.workingDirectory=b.workingDirectory,d.url=b.url,d.Thread._tid=b.tid;else if("eval"===b.threadjsCmd)this._scope.eval(b.script);else if("importScripts"===b.threadjsCmd){b=b.srcs;for(c=0;c<b.length;++c){var a=b[c];0>a.indexOf("://")&&(a=d.Thread.workingDirectory+a);b[c]=a}importScripts.apply(null,b)}else if("call"===b.threadjsCmd)this._scope.eval(b.funcName).apply(null,
b.args);else if("construct"===b.threadjsCmd)b.args.splice(0,0,""),new (Function.prototype.bind.apply(eval(b.typeName),b.args));else if("postEvent"===b.threadjsCmd)this.dispatchEvent(b.threadEvent);else if("permitThread"===b.threadjsCmd)for(b=b.tid,a=d.Thread._children,c=0;c<a.length;++c)a[c]._tid===b?a[c].start():b.substring(0,a[c]._tid.length)===a[c]._tid&&a[c].postMessage({threadjsCmd:"permitThread",tid:b});else this.dispatchEvent(c)};return a}(d.EventDispatcher);d.Context=e})(threadjs||(threadjs=
{}));
(function(d){var e=function(e){function a(){for(var c=[],b=0;b<arguments.length;b++)c[b-0]=arguments[b];e.call(this);this._worker=null;this._isStarted=this._isTerminated=!1;this._inbox=[];this._workerURL=null;this.postEvent=this.postEvent.bind(this);a._children.push(this);this._initSrcs=c;c=a._tid;a._totalChildCount++;b=a._totalChildCount.toString();1===b.length?b="00"+b:2===b.length&&(b="0"+b);this._tid=c=("000"!==c?c+".":"")+b;a.isMainThread?a.handleRequest(this._tid):a.parent.postMessage({threadjsCmd:"requestThread",tid:this._tid})}
__extends(a,e);Object.defineProperty(a,"scope",{get:function(){return a.isMainThread?window:a.parent._scope},enumerable:!0,configurable:!0});Object.defineProperty(a,"threadID",{get:function(){return a._tid+""},enumerable:!0,configurable:!0});Object.defineProperty(a.prototype,"isStarted",{get:function(){return this._isStarted},enumerable:!0,configurable:!0});Object.defineProperty(a.prototype,"isTerminated",{get:function(){return this._isTerminated},enumerable:!0,configurable:!0});Object.defineProperty(a.prototype,
"threadID",{get:function(){return this._tid+""},enumerable:!0,configurable:!0});a.prototype.start=function(){if(!this._isStarted){this._isStarted=!0;var c=d.url;0>c.indexOf("://")&&(c=a.workingDirectory+c);if(d.allowInlineWorkers&&"undefined"!==typeof URL){this._workerURL=URL.createObjectURL(new Blob(["importScripts('"+c+"');"]));try{this._worker=new Worker(this._workerURL)}catch(b){URL.revokeObjectURL(this._workerURL),this._workerURL=null,this._worker=new Worker(c)}}else this._worker=new Worker(c);
this.worker_message=this.worker_message.bind(this);this._worker.addEventListener("message",this.worker_message,!1);this.worker_error=this.worker_error.bind(this);this._worker.addEventListener("error",this.worker_error,!1);this.postMessage({threadjsCmd:"init",workingDirectory:a.workingDirectory,url:c,tid:this._tid});if(0<this._initSrcs.length)for(c=0;c<this._initSrcs.length;++c){var e=this._initSrcs[c];"string"===typeof e?this.importScripts(e):this.addScripts(e)}if(null!==this._inbox)for(c=0;c<this._inbox.length;++c)this.postMessage(this._inbox[c]);
this._inbox=null;this.dispatchEvent(new d.ThreadEvent("started"))}};a.prototype.terminate=function(c){void 0===c&&(c=0);this._isTerminated||(this._isTerminated=!0,this._worker.removeEventListener("message",this.worker_message,!1),this._worker.removeEventListener("error",this.worker_error,!1),this._worker.terminate(),null!==this._workerURL&&URL.revokeObjectURL(this._workerURL),this._workerURL=this._worker=null,a._children.splice(a._children.indexOf(this),1),a.isMainThread?a.handleTermination(this._tid):
a.parent.postMessage({threadjsCmd:"terminatedThread",tid:this._tid}),this.dispatchEvent({type:"terminate",exitCode:c}))};a.terminate=function(c){void 0===c&&(c=0);if(null!==a.parent)a.parent.postMessage({threadjsCmd:"terminate",exitCode:c});else try{console.warn("Attempted to terminate the main thread! This will have no effect!")}catch(b){}};a.prototype.importScripts=function(){for(var a=[],b=0;b<arguments.length;b++)a[b-0]=arguments[b];this.postMessage({threadjsCmd:"importScripts",srcs:a})};a.prototype.addScripts=
function(){for(var a=[],b=0;b<arguments.length;b++)a[b-0]=arguments[b];for(b=0;b<a.length;++b){var d=a[b];"function"===typeof d?this.exec(d):this.eval(d.innerHTML)}};a.prototype.define=function(a,b){if("function"===typeof a)this.eval(a);else if("string"===typeof a)this.eval("var "+a+" = "+b+";");else throw Error("Unknown varNameOrFunc type ("+typeof a+"). Must be a string variable name or a function reference!");};a.prototype.postMessage=function(a){if(this._isTerminated)throw Error("Worker is already terminated!");
this._isStarted?this._worker.postMessage(a):this._inbox.push(a)};a.prototype.postEvent=function(a,b){void 0===b&&(b=null);if("string"===typeof a)a=new d.ThreadEvent(a,b);else if(a instanceof Event)a=d.ThreadEvent.copyNative(a);else if("string"!==typeof a.type)throw Error("Missing string event type on supplied threadEvent parameter!");this.postMessage({threadjsCmd:"postEvent",threadEvent:a})};a.prototype.call=function(a){for(var b=[],d=1;d<arguments.length;d++)b[d-1]=arguments[d];this.postMessage({threadjsCmd:"call",
funcName:a,args:b})};a.prototype.exec=function(a){for(var b=[],d=1;d<arguments.length;d++)b[d-1]=arguments[d];this.eval("var threadjsTempFunc = "+a.toString()+";");b.splice(0,0,"threadjsTempFunc");this.call.apply(this,b)};a.prototype.construct=function(a){for(var b=[],d=1;d<arguments.length;d++)b[d-1]=arguments[d];this.postMessage({threadjsCmd:"construct",typeName:a,args:b})};a.prototype.eval=function(a){this.postMessage({threadjsCmd:"eval",script:a.toString()})};a.handleRequest=function(c){a.isMainThread&&
(a._pendingThreadIds.push(c),a._liveThreadIds.length<a._maxWorkers&&a.permit(c))};a.permitCheck=function(){if(a.isMainThread)for(;0<a._pendingThreadIds.length&&a._liveThreadIds.length<a._maxWorkers;)a.permit(a._pendingThreadIds[0])};a.permit=function(c){if(a.isMainThread){for(var b=0;b<a._pendingThreadIds.length;++b)if(a._pendingThreadIds[b]===c){a._pendingThreadIds.splice(b,1);break}a._liveThreadIds.push(c);for(b=0;b<a._children.length;++b)a._children[b]._tid===c?a._children[b].start():c.substring(0,
a._children[b]._tid.length)===a._children[b]._tid&&a._children[b].postMessage({threadjsCmd:"permitThread",tid:c})}};a.handleTermination=function(c){if(a.isMainThread){for(var b=0;b<a._pendingThreadIds.length;++b)a._pendingThreadIds[b]===c?(a._pendingThreadIds.splice(b,1),b--):0===a._pendingThreadIds[b].indexOf(c+".")&&(a._pendingThreadIds.splice(b,1),b--);for(b=0;b<a._liveThreadIds.length;++b)a._liveThreadIds[b]===c?(a._liveThreadIds.splice(b,1),b--):0===a._liveThreadIds[b].indexOf(c+".")&&(a._liveThreadIds.splice(b,
1),b--);a.permitCheck()}};a.prototype.worker_message=function(c){if(!this._isTerminated){var b=c.data;"postEvent"===b.threadjsCmd?this.dispatchEvent(b.threadEvent):"terminate"===b.threadjsCmd?this.terminate(b.exitCode):"requestThread"===b.threadjsCmd?a.isMainThread?a.handleRequest(b.tid):a.parent.postMessage({threadjsCmd:"requestThread",tid:b.tid}):"terminatedThread"===b.threadjsCmd?a.isMainThread?a.handleTermination(b.tid):a.parent.postMessage({threadjsCmd:"terminatedThread",tid:b.tid}):this.dispatchEvent(c)}};
a.prototype.worker_error=function(a){this._isTerminated||this.dispatchEvent(a)};a.MESSAGE="message";a.ERROR="error";a.TERMINATE="terminate";a.START="start";a.parent=null;a._children=[];a._tid="000";a._totalChildCount=0;a._pendingThreadIds=[];a._liveThreadIds=[];a._maxWorkers=4;return a}(d.EventDispatcher);d.Thread=e;(function(){if("undefined"!==typeof Window){var f=navigator.hardwareConcurrency||4;1>f?f=1:16<f&&(f=16);e._maxWorkers=f;e.isMainThread=!0;e.workingDirectory=document.location.toString().substring(0,
document.location.toString().lastIndexOf("/")+1)}else e.isMainThread=!1,e.parent=new d.Context(self);if("undefined"===typeof e.scope.Thread)e.scope.Thread=e;else try{console.warn("Could not import Thread class, there is a naming collision!")}catch(a){}})()})(threadjs||(threadjs={}));
(function(d){var e=function(){function a(a,b){void 0===b&&(b=null);this.type=a;this.data=b}a.copyNative=function(c){var b=new a(c.type),d;for(d in c){var e=c[d],f=JSON.stringify(e);if("undefined"!==typeof f)try{e=JSON.parse(f),b[d]=e}catch(g){}}return b};return a}();d.ThreadEvent=e;if("undefined"===typeof d.Thread.scope.ThreadEvent)d.Thread.scope.ThreadEvent=e;else try{console.warn("Could not import ThreadEvent class, there is a naming collision!")}catch(f){}})(threadjs||(threadjs={}));
